

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.14. TokenPattern &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.8.15. TokenRegexp" href="token_regexp.html" />
    <link rel="prev" title="7.8.13. TokenNgram" href="token_ngram.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/tokenizers/token_pattern.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="token_ngram.html" title="7.8.13. TokenNgram"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.14. </span><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenpattern">
<h1><span class="section-number">7.8.14. </span><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code><a class="headerlink" href="#tokenpattern" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.14.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> is a tokenizer which is used to extract tokens by regular expression.
This tokenizer extracts only token that matches the specified regular expression.</p>
<p>You can also specify multiple patterns of regular expression.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.14.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> has optional parameter.</p>
<p>Specify one pattern:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenPattern(&quot;pattern&quot;, PATTERN)
</pre></div>
</div>
<p>Specify multiple patterns:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenPattern(&quot;pattern&quot;, PATTERN_1, &quot;pattern&quot;, PATTERN_2, ... &quot;pattern&quot;, PATTERN_N)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> can accept multiple patterns as above.</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.14.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is an example of <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code>. As <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> only extracts the token which matches the specified regular expression, it is able to filter search results which only matches the extracted token.</p>
<p>For example, let’s compare search results by specific keywords. One is listed in <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> pattern, and the other is not listed in <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> pattern.</p>
<p>There are menus which contains both of specific keywords in <code class="docutils literal notranslate"><span class="pre">Foods</span></code> table.</p>
<p>Here is the sample schema and data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Foods TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Foods name COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Keywords TABLE_PAT_KEY ShortText --default_tokenizer &#39;TokenPattern(&quot;pattern&quot;, &quot;Apple|Orange&quot;)&#39;
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Keywords index COLUMN_INDEX Foods name
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Foods
[
{&quot;name&quot;: &quot;Apple Pie&quot;},
{&quot;name&quot;: &quot;Orange Pie&quot;}
{&quot;name&quot;: &quot;Raspberry Pie&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>Then search <code class="docutils literal notranslate"><span class="pre">Apple</span> <span class="pre">Pie</span></code> with <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Apple</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Foods --match_columns name --query &#39;Apple&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;Apple Pie&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>In above example, <code class="docutils literal notranslate"><span class="pre">Apple</span></code> matches pattern which is specified as <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> pattern, <code class="docutils literal notranslate"><span class="pre">select</span></code> matches <code class="docutils literal notranslate"><span class="pre">Apple</span> <span class="pre">Pie</span></code>.</p>
<p>Then search <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> with <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Raspberry</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Foods --match_columns name --query &#39;Raspberry&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         0
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>In above example, even though <code class="docutils literal notranslate"><span class="pre">Foods</span></code> table contains <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> record, <code class="docutils literal notranslate"><span class="pre">select</span></code> doesn’t match it because <code class="docutils literal notranslate"><span class="pre">Raspberry</span></code> doesn’t match to <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code> pattern..</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.8.14.4. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/tokenize.html"><span class="doc">tokenize</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.14. <code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.14.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.8.14.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.8.14.3. Usage</a></li>
<li><a class="reference internal" href="#see-also">7.8.14.4. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="token_ngram.html"
                        title="previous chapter"><span class="section-number">7.8.13. </span><code class="docutils literal notranslate"><span class="pre">TokenNgram</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="token_regexp.html"
                        title="next chapter"><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             >next</a> |</li>
        <li class="right" >
          <a href="token_ngram.html" title="7.8.13. TokenNgram"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.14. </span><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>